//================================================
/*

Ambient Aurea
Bring your image to an ambient lighting effect with just one click on the button.
Copyright (C) 2013 Stefan vd
www.stefanvd.net

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================

function $(id) { return document.getElementById(id); }
var default_opacity = 80;
var default_arangeblur = 70;
var default_arangespread = 5;

// Firefox read pref
var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

// Option to save current value to window.localStorage
function save_options(){
	prefManager.setCharPref("extensions.AmbientAurea.interval", $('interval').value);
	prefManager.setCharPref("extensions.AmbientAurea.lightcolor", $('lightcolor').value);
	if($('contextmenus').checked) prefManager.setBoolPref("extensions.AmbientAurea.contextmenus", true);
	else prefManager.setBoolPref("extensions.AmbientAurea.contextmenus", false);
	if($('ambilight').checked)prefManager.setBoolPref("extensions.AmbientAurea.ambilight", true);
	else prefManager.setBoolPref("extensions.AmbientAurea.ambilight", false);
	prefManager.setCharPref("extensions.AmbientAurea.ambilightrangeblurradius", $('ambilightrangeblurradius').value);
	prefManager.setCharPref("extensions.AmbientAurea.ambilightrangespreadradius", $('ambilightrangespreadradius').value);
	if($('ambilightfixcolor').checked)prefManager.setBoolPref("extensions.AmbientAurea.ambilightfixcolor", true);
	else prefManager.setBoolPref("extensions.AmbientAurea.ambilightfixcolor", false);
	if($('ambilightvarcolor').checked)prefManager.setBoolPref("extensions.AmbientAurea.ambilightvarcolor", true);
	else prefManager.setBoolPref("extensions.AmbientAurea.ambilightvarcolor", false);
	prefManager.setCharPref("extensions.AmbientAurea.ambilightcolorhex", $('ambilightcolorhex').value);
	if($('ambilight4color').checked)prefManager.setBoolPref("extensions.AmbientAurea.ambilight4color", true);
	else prefManager.setBoolPref("extensions.AmbientAurea.ambilight4color", false);
	prefManager.setCharPref("extensions.AmbientAurea.ambilight1colorhex", $('ambilight1colorhex').value);
	prefManager.setCharPref("extensions.AmbientAurea.ambilight2colorhex", $('ambilight2colorhex').value);
	prefManager.setCharPref("extensions.AmbientAurea.ambilight3colorhex", $('ambilight3colorhex').value);
	prefManager.setCharPref("extensions.AmbientAurea.ambilight4colorhex", $('ambilight4colorhex').value);	
	if($('fadein').checked) prefManager.setBoolPref("extensions.AmbientAurea.fadein", true);
	else prefManager.setBoolPref("extensions.AmbientAurea.fadein", false);		
	if($('fadeout').checked) prefManager.setBoolPref("extensions.AmbientAurea.fadeout", true);
	else prefManager.setBoolPref("extensions.AmbientAurea.fadeout", false);		
	if($('sharebar').checked) prefManager.setBoolPref("extensions.AmbientAurea.sharebar", true);
	else prefManager.setBoolPref("extensions.AmbientAurea.sharebar", false);
	if($('count').checked) prefManager.setBoolPref("extensions.AmbientAurea.count", true);
	else prefManager.setBoolPref("extensions.AmbientAurea.count", false);
	if($('sharebar').checked) prefManager.setBoolPref("extensions.AmbientAurea.sharebar", true);
	prefManager.setCharPref("extensions.AmbientAurea.slideshowrefresh", $('slideshowrefresh').value);
}

// Option to read current value from window.localStorage
// nothing must be set here
// firefox read it from the pref.js file


function read_options(){
	if(prefManager.getCharPref("extensions.AmbientAurea.interval"))$('interval').value = prefManager.getCharPref("extensions.AmbientAurea.interval");
	else $('interval').value = 80;
	if(prefManager.getCharPref("extensions.AmbientAurea.lightcolor")){$('lightcolor').value = prefManager.getCharPref("extensions.AmbientAurea.lightcolor");}
	else {$('lightcolor').value = '#000000';}	
	if(prefManager.getBoolPref("extensions.AmbientAurea.contextmenus") == true)$('contextmenus').checked = true;
	if(prefManager.getBoolPref("extensions.AmbientAurea.ambilight") == true){$('ambilight').checked = true;}
	else {$('arangespread').disabled = true;$('ambilightrangespreadradius').disabled = true;$('arangeblur').disabled = true;$('ambilightrangeblurradius').disabled = true;$('ambilightfixcolor').disabled = true;$('ambilightvarcolor').disabled = true;$('ambilightcolorhex').disabled = true;$('ambilight4color').disabled = true;$('ambilight1colorhex').disabled = true;$('ambilight2colorhex').disabled = true;$('ambilight3colorhex').disabled = true;$('ambilight4colorhex').disabled = true;}
	if(prefManager.getCharPref("extensions.AmbientAurea.ambilightrangeblurradius"))$('ambilightrangeblurradius').value = prefManager.getCharPref("extensions.AmbientAurea.ambilightrangeblurradius");
	else $('ambilightrangeblurradius').value = 50;
	if(prefManager.getCharPref("extensions.AmbientAurea.ambilightrangespreadradius"))$('ambilightrangespreadradius').value = prefManager.getCharPref("extensions.AmbientAurea.ambilightrangespreadradius");
	else $('ambilightrangespreadradius').value = 5;
	if(prefManager.getBoolPref("extensions.AmbientAurea.ambilightfixcolor") == true)$('ambilightfixcolor').checked = true;
	if(prefManager.getBoolPref("extensions.AmbientAurea.ambilightvarcolor") == true){$('ambilightvarcolor').checked = true;}
	if(prefManager.getCharPref("extensions.AmbientAurea.ambilightcolorhex"))$('ambilightcolorhex').value = prefManager.getCharPref("extensions.AmbientAurea.ambilightcolorhex");
	else $('ambilightcolorhex').value = '#47C2FF';
	if(prefManager.getBoolPref("extensions.AmbientAurea.ambilight4color") == true)$('ambilight4color').checked = true;
	if(prefManager.getCharPref("extensions.AmbientAurea.ambilight1colorhex"))$('ambilight1colorhex').value = prefManager.getCharPref("extensions.AmbientAurea.ambilight1colorhex");
	else $('ambilight1colorhex').value = '#FF0000';
	if(prefManager.getCharPref("extensions.AmbientAurea.ambilight2colorhex"))$('ambilight2colorhex').value = prefManager.getCharPref("extensions.AmbientAurea.ambilight2colorhex");
	else $('ambilight2colorhex').value = '#FFEE00';
	if(prefManager.getCharPref("extensions.AmbientAurea.ambilight3colorhex"))$('ambilight3colorhex').value = prefManager.getCharPref("extensions.AmbientAurea.ambilight3colorhex");
	else $('ambilight3colorhex').value = '#00FF00';
	if(prefManager.getCharPref("extensions.AmbientAurea.ambilight4colorhex"))$('ambilight4colorhex').value = prefManager.getCharPref("extensions.AmbientAurea.ambilight4colorhex");
	else $('ambilight4colorhex').value = '#0000FF';
	if(prefManager.getBoolPref("extensions.AmbientAurea.fadein") == true)$('fadein').checked = true;	
	if(prefManager.getBoolPref("extensions.AmbientAurea.fadeout") == true)$('fadeout').checked = true;
	if(prefManager.getBoolPref("extensions.AmbientAurea.sharebar") == true)$('sharebar').checked = true;
	if(prefManager.getBoolPref("extensions.AmbientAurea.slideshow") == true)$('slideshow').checked = true;
	if(prefManager.getCharPref("extensions.AmbientAurea.slideshowrefresh"))$('slideshowrefresh').value = prefManager.getCharPref("extensions.AmbientAurea.slideshowrefresh");
	else $('interval').value = 5;
	
	// load tab div
	var tabListItems = $('navbar').childNodes;
	for ( var i = 0; i < tabListItems.length; i++ ) {
		if ( tabListItems[i].nodeName == 'LI' ) {
		var tabLink = getFirstChildWithTagName( tabListItems[i], 'A' );
		var id = getHash( tabLink.getAttribute('onclick') );
		tabLinks[id] = tabLink;
		contentDivs[id] = $( id );
        }
    }
  
    // Assign onclick events to the tab links, and
    // highlight the first tab
    var i = 0;
 
    for ( var id in tabLinks ) {
    	tabLinks[id].onclick = showTab;
		tabLinks[id].onfocus = function() { this.blur() };
		if ( i == 0 ) tabLinks[id].className = 'navbar-item-selected';
		i++;
    }
    
    // Hide all content divs except the first
    var i = 0;
 
    for ( var id in contentDivs ) {
    	if ( i != 0 ) contentDivs[id].className = 'page hidden';
        i++;
    }

    // display version number
    function displayVersionNumber() {
	// Firefox 4 and later; Mozilla 2 and later
	try {
    Components.utils.import("resource://gre/modules/AddonManager.jsm");
    AddonManager.getAddonByID("ambientaurea@stefanvd.net", function(addon) {
		$("version_number").textContent = addon.version;
	})
	} catch (ex) {} // silently fail
    }
    displayVersionNumber();
	
	// enable paint job
	drawImage();
	
var example2 = $('example2'); // firefox fix	
// default example2 is not display
example2.style.opacity = 0;example2.style.display = 'none';	
}

// animation browser engine
window.requestAnimFrame = function(){
    return (
        window.requestAnimationFrame       || 
        window.webkitRequestAnimationFrame || 
        window.mozRequestAnimationFrame    || 
        window.oRequestAnimationFrame      || 
        window.msRequestAnimationFrame     || 
        function(/* function */ callback){
            window.setTimeout(callback, 1000 / 60);
        }
    );
}();

// ambilight draw code
function drawImage(){
	var totlshowtime = $("beeld");
	var ambilight = $('ambilight'); // firefox fix
	if(ambilight.checked == true){
    var showtime = $("beeld");
	var getblur = $('ambilightrangeblurradius').value + "px";
	var getspread = $('ambilightrangespreadradius').value + "px";
	
	var k = 1;
	
	
	var ambilightvarcolor = $('ambilightvarcolor'); // firefox fix
	var ambilightfixcolor = $('ambilightfixcolor'); // firefox fix
	var ambilight4color = $('ambilight4color'); // firefox fix
	if(ambilightvarcolor.checked == true){
    var sourceWidth = totlshowtime.width;
    var sourceHeight = totlshowtime.height;
    
var totlcheckcanvas = $("totlCanvas1");
if(totlcheckcanvas){}else{
 	var totlnewcanvas = document.createElement("canvas");
	totlnewcanvas.setAttribute('id','totlCanvas1');
	totlnewcanvas.width = "4";
	totlnewcanvas.height = "1";
	totlnewcanvas.style.display = "none";
	document.body.appendChild(totlnewcanvas);
	}

var canvas = $("totlCanvas1");
var context = canvas.getContext("2d");
var colorlamp1X = (sourceWidth * 50) /100; // up midden
var colorlamp1Y = (sourceHeight * 95) /100;
var colorlamp2X = (sourceWidth * 95) /100; // right midden
var colorlamp2Y = (sourceHeight * 50) /100;
var colorlamp3X = (sourceWidth * 50) /100; // down midden
var colorlamp3Y = (sourceHeight * 5) /100;
var colorlamp4X = (sourceWidth * 5) /100; // left midden
var colorlamp4Y = (sourceHeight * 50) /100;
	
	context.drawImage(showtime, colorlamp1X, colorlamp1Y, 1, 1, 0, 0, 1, 1);
	context.drawImage(showtime, colorlamp2X, colorlamp2Y, 1, 1, 1, 0, 1, 1);
	context.drawImage(showtime, colorlamp3X, colorlamp3Y, 1, 1, 2, 0, 1, 1);
	context.drawImage(showtime, colorlamp4X, colorlamp4Y, 1, 1, 3, 0, 1, 1);
	
    var imageData = context.getImageData(0, 0, 1, 1);
    var data = imageData.data;

function rgbToHex(r, g, b) {
    if (r > 255 || g > 255 || b > 255)
        throw "Invalid color component";
    return ((r << 16) | (g << 8) | b).toString(16);
}

    var p1 = context.getImageData(0 , 0, 1, 1).data; 
    var p2 = context.getImageData(1 , 0, 1, 1).data; 
    var p3 = context.getImageData(2 , 0, 1, 1).data; 
    var p4 = context.getImageData(3 , 0, 1, 1).data; 
    var hex1 = "#" + ("000000" + rgbToHex(p1[0], p1[1], p1[2])).slice(-6);
    var hex2 = "#" + ("000000" + rgbToHex(p2[0], p2[1], p2[2])).slice(-6);
    var hex3 = "#" + ("000000" + rgbToHex(p3[0], p3[1], p3[2])).slice(-6);
    var hex4 = "#" + ("000000" + rgbToHex(p4[0], p4[1], p4[2])).slice(-6);

	totlshowtime.style.setProperty("box-shadow", "0px 0px 5px black , 0px -20px " + getblur + " " + getspread + " " + hex3 + ", 0px 20px " + getblur + " " + getspread + " " + hex1 + ", 20px 0px " + getblur + " " + getspread + " " + hex2 + ", -20px 0px " + getblur + " " + getspread + " " + hex4 + "", "");
	} else if(ambilightfixcolor.checked == true){
	var fixhex = $("ambilightcolorhex").value;
	if(fixhex)fixhex = fixhex;else fixhex = '#000000';
	totlshowtime.style.setProperty("box-shadow", "0px 0px 5px black , 0px -20px " + getblur + " " + getspread + " " + fixhex + ", 0px 20px " + getblur + " " + getspread + " " + fixhex + ", 20px 0px " + getblur + " " + getspread + " " + fixhex + ", -20px 0px " + getblur + " " + getspread + " " + fixhex + "", "");
	} else if(ambilight4color.checked == true){
	var fix1hex = $("ambilight1colorhex").value;
	var fix2hex = $("ambilight2colorhex").value;
	var fix3hex = $("ambilight3colorhex").value;
	var fix4hex = $("ambilight4colorhex").value;
	if(fix1hex)fix1hex = fix1hex;else fix1hex = '#000000';
	if(fix2hex)fix2hex = fix2hex;else fix2hex = '#000000';
	if(fix3hex)fix3hex = fix3hex;else fix3hex = '#000000';
	if(fix4hex)fix4hex = fix4hex;else fix4hex = '#000000';
	totlshowtime.style.setProperty("box-shadow", "0px 0px 5px black , 0px -20px " + getblur + " " + getspread + " " + fix1hex + ", 0px 20px " + getblur + " " + getspread + " " + fix2hex + ", 20px 0px " + getblur + " " + getspread + " " + fix3hex + ", -20px 0px " + getblur + " " + getspread + " " + fix4hex + "", "");
	}
	
	window.requestAnimFrame(drawImage);	
}else{totlshowtime.style.setProperty("box-shadow", "", "");}
}

// Fade engine
//  Variable for the fade in and out effect
var opacity = 0;

var ReducingFinished = true;
var OpacityLevelIncrement = 10;   //  Percentage value: 1-100

//  Function determines whether we show or hide the item referenced by ElementID
function fader(ActionToTake)
{
  DIVElementById = $('example2');
  if (ActionToTake == 'hide')
  { opacity = default_opacity; reduceOpacity(); }
  else if (ActionToTake == 'show')
  { increaseOpacity(); }
}

//  Makes div increase
function increaseOpacity()
{
DIVElementById.style.display = '';
  //  If opacity level is less than default_opacity, we can still increase the opacity
  if ((opacity < default_opacity) && (ReducingFinished == true))
  {
	if ((opacity > (default_opacity-10)) && (ReducingFinished == true)){
    ReducingFinished = true;
    opacity  += (default_opacity - opacity);
    DIVElementById.style.opacity = opacity/100;
	window.requestAnimFrame(increaseOpacity);
	}
	else {
    ReducingFinished = true;
    opacity  += OpacityLevelIncrement;
    DIVElementById.style.opacity = opacity/100;
	window.requestAnimFrame(increaseOpacity);
	}
  }
  else
  {
    ReducingFinished = false;
  }
}

//  Makes div reduce
function reduceOpacity() 
{
  //  If opacity level is greater than 0, we can still reduce the opacity
  if ((opacity > 0) && (ReducingFinished == false))
  {
    ReducingFinished = false;
    opacity  -= OpacityLevelIncrement;
    DIVElementById.style.opacity = opacity/100;
	window.requestAnimFrame(reduceOpacity);
  }
  else
  {
    ReducingFinished = true;

    //  When finished, make sure the DIVElementById is set to remove element
    if (DIVElementById.style.opacity = '0')
    {DIVElementById.style.display = 'none';}
  }
}

// tabel script
    var tabLinks = new Array();
    var contentDivs = new Array();
 
    function showTab() {
      var selectedId = getHash( this.getAttribute('onclick') );
 
      // Highlight the selected tab, and dim all others.
      // Also show the selected content div, and hide all others.
      for ( var id in contentDivs ) {
        if ( id == selectedId ) {
          tabLinks[id].className = 'navbar-item-selected';
          contentDivs[id].className = 'page';
        } else {
          tabLinks[id].className = 'navbar-item';
          contentDivs[id].className = 'page hidden';
        }
      }
 
      // Stop the browser following the link
      return false;
    }
 
    function getFirstChildWithTagName( element, tagName ) {
      for ( var i = 0; i < element.childNodes.length; i++ ) {
        if ( element.childNodes[i].nodeName == tagName ) return element.childNodes[i];
      }
    }
 
    function getHash( url ) {
      var hashPos = url.lastIndexOf ( '#' );
      return url.substring( hashPos + 1 );
    }

// fade effects control -> not when loaded page
function lightscontrol() {
var jump = $('interval').value;
default_opacity = jump;
var onoffrange = $('onoffrange'); // firefox fix
if(onoffrange.value == 0)
{
var fadeout = $('fadeout'); // firefox fix
var example2 = $('example2'); // firefox fix
if(fadeout.checked == true){ReducingFinished = false;fader('hide');}else{example2.style.opacity = 0;example2.style.display = 'none';}
}
else{
var fadein = $('fadein'); // firefox fix
var example2 = $('example2'); // firefox fix
if(fadein.checked == true){ReducingFinished = true;fader('show');}else{example2.style.opacity = jump/100;example2.style.display = '';}
}
}

function test() {
 // firefox fix
var ambilight = $('ambilight');
var example2 = $('example2');

if(ambilight.checked == true)
{drawImage();$('arangespread').disabled = false;$('ambilightrangespreadradius').disabled = false;$('arangeblur').disabled = false;$('ambilightrangeblurradius').disabled = false;$('ambilightfixcolor').disabled = false;$('ambilightvarcolor').disabled = false;$('ambilightcolorhex').disabled = false;$('ambilight4color').disabled = false;$('ambilight1colorhex').disabled = false;$('ambilight2colorhex').disabled = false;$('ambilight3colorhex').disabled = false;$('ambilight4colorhex').disabled = false;}
else {drawImage();$('arangespread').disabled = true;$('ambilightrangespreadradius').disabled = true;$('arangeblur').disabled = true;$('ambilightrangeblurradius').disabled = true;$('ambilightfixcolor').disabled = true;$('ambilightvarcolor').disabled = true;$('ambilightcolorhex').disabled = true;$('ambilight4color').disabled = true;$('ambilight1colorhex').disabled = true;$('ambilight2colorhex').disabled = true;$('ambilight3colorhex').disabled = true;$('ambilight4colorhex').disabled = true;}

example2.style.backgroundColor =  $('lightcolor').value;
}

// Current year
function yearnow() {
var today = new Date(); var y0 = today.getFullYear();$("yearnow").textContent = y0;
}

/* Option page body action */
// Read current value settings
window.addEventListener('load', function() {
read_options();
yearnow();
// remove loading screen
$('loading').style.display = "none";
});

document.addEventListener('DOMContentLoaded', function () {
// Detect click / change to save the page and test it.
var inputs = document.querySelectorAll('input');
for (var i = 0; i < inputs.length; i++) {inputs[i].addEventListener('change', test);inputs[i].addEventListener('change', save_options);}

// Close yellow bar
$("managed-prefs-text-close").addEventListener('click', function() {$("managed-prefs-banner").style.display = "none";});

// Detect lightcolor change
$("lightcolor").addEventListener('change', function() {$('example2').style.background = this.value;save_options();});

// Interval
$("interval").addEventListener('change', function() {showValue(this.value);save_options();});

// Light switch
$("onoffrange").addEventListener('change', function() {lightscontrol();});

// Arangeblur
$("arangeblur").addEventListener('change', function() {showambilightblurValue(this.value);save_options();});
$("ambilightrangeblurradius").addEventListener('change', function() {showambilightblurValue(this.value);save_options();});

// Arangespread
$("arangespread").addEventListener('change', function() {showambilightspreadValue(this.value);save_options();});
$("ambilightrangespreadradius").addEventListener('change', function() {showambilightspreadValue(this.value);save_options();});

// Save KB download
$("tabbasic").addEventListener('click', function() {$('welcomeguide').src = "";});
$("tabvisual").addEventListener('click', function() {$('welcomeguide').src = "";});
$("tabguide").addEventListener('click', function() {$('welcomeguide').src = "http://www.stefanvd.net/project/aafirefoxguide.htm";$("managed-prefs-banner").style.display = "none";});

// Share button
$("productsharebutton").addEventListener('click', function() {
$('sharebuttonspopup').src = "http://www.stefanvd.net/project/aafirefoxshare.htm";$("sharepopup").style.display = "";
});

$("productsharebuttonclose").addEventListener('click', function() {
$('sharebuttonspopup').src = "";$("sharepopup").style.display = "none";
});

});