//================================================
/*

Ambient Aurea
Bring your image to an ambient lighting effect with just one click on the button.
Copyright (C) 2013 Stefan vd
www.stefanvd.net

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================

// main script
// AmbientAurea namespace.
if ("undefined" == typeof(AmbientAurea)) {
  var AmbientAurea = {};
};

(function(ns) {
    ns.extension_id = "Ambient Aurea (Firefox) extension";
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
    ns.init = function () {

// welcome page
var firstrun = Services.prefs.getBoolPref("extensions.AmbientAurea.firstrun");
var curVersion = "1.0.0.21";

if (firstrun) {
// Adding button by default ------------
  var myId    = "AmbientAurea-button"; // ID of button to add
  var afterId = "urlbar-container";    // ID of element to insert after
  var navBar  = document.getElementById("nav-bar");
  var currentSet = navBar.getAttribute("currentset");
    if (!currentSet)
        currentSet = navBar.currentSet;

    var curSet = currentSet.split(",");
    if (curSet.indexOf(myId) == -1){
		var set = curSet.concat(myId);
		navBar.setAttribute("currentset", set.join(","));
		navBar.currentSet = set.join(",");
		document.persist(navBar.id, "currentset");
    try {
      BrowserToolboxCustomizeDone(true);
    }
    catch (e) {}
  }
//------------
  Services.prefs.setBoolPref("extensions.AmbientAurea.firstrun", false);
  Services.prefs.setCharPref("extensions.AmbientAurea.installedVersion", curVersion);
  /* Code related to firstrun */
  window.setTimeout(function(){ gBrowser.selectedTab = gBrowser.addTab("http://www.stefanvd.net/project/aafirefoxguide.htm"); }, 1000);
  window.setTimeout(function(){ gBrowser.selectedTab = gBrowser.addTab("http://www.stefanvd.net/project/aafirefox.htm"); }, 1000);
} else {
  try {
    var installedVersion = Services.prefs.getCharPref("extensions.AmbientAurea.installedVersion");
    if (curVersion > installedVersion) {
      Services.prefs.setCharPref("extensions.AmbientAurea.installedVersion", curVersion);
      /* Code related to upgrade */
    }
  } catch (ex) {
    /* Code related to a reinstall */
  }
}
	
	// For accessing browser window from sidebar code.
    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
               .getInterface(Components.interfaces.nsIWebNavigation)
               .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
               .rootTreeItem
               .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
               .getInterface(Components.interfaces.nsIDOMWindow);
    var gBrowser = mainWindow.gBrowser;
    if (gBrowser.addEventListener) {
        gBrowser.addEventListener("load",pageLoaded,true);
    }
	
	function pageLoaded(aEvent) {
    if ((aEvent.originalTarget.nodeName == '#document') && (aEvent.originalTarget.defaultView.location.href == gBrowser.currentURI.spec)) 
    {
	var tab = documentToTab(gBrowser.contentDocument);
	
	// check if not on firefox "chrome" page
	var checktaburl = window.top.getBrowser().selectedBrowser.contentWindow.location.protocol;
	if(checktaburl != "chrome:"){	
	firefox.tabs.executeScript(tab, {file: "chrome://AmbientAurea/content/js/content.js"});
	}
	
				var contextmenus = prefManager.getBoolPref("extensions.AmbientAurea.contextmenus");
				if (contextmenus) {
				actionmenu();
				} else {
				document.getElementById("AmbientAureaimage").style.display = "none";
				}

    } // end close content script
	}
				
function actionmenu() {
	// context menu
	var AreaContextMenu = document.getElementById("contentAreaContextMenu");
	if (AreaContextMenu) {AreaContextMenu.addEventListener("popupshowing", ShowHideItems, false);}
					
		function ShowHideItems(event)
		{
			if (document.popupNode.localName.toUpperCase() == "IMG") {
				document.getElementById("AmbientAureaimage").style.display = "block";
			} else {
				document.getElementById("AmbientAureaimage").style.display = "none";
			}
		}
}

        firefox.extension.onRequest.addListener(function(request, sender, sendResponse) {
            if ( request.name == "aarequest" ) {
				sendResponse({getimgurl: prefManager.getCharPref("extensions.AmbientAurea.getimgurl"), sharebar: prefManager.getBoolPref("extensions.AmbientAurea.sharebar"), lightcolor: prefManager.getCharPref("extensions.AmbientAurea.lightcolor"), fadein: prefManager.getBoolPref("extensions.AmbientAurea.fadein"), fadeout: prefManager.getBoolPref("extensions.AmbientAurea.fadeout"), interval: prefManager.getCharPref("extensions.AmbientAurea.interval"), ambilight: prefManager.getBoolPref("extensions.AmbientAurea.ambilight"), ambilightrangeblurradius: prefManager.getCharPref("extensions.AmbientAurea.ambilightrangeblurradius"), ambilightrangespreadradius: prefManager.getCharPref("extensions.AmbientAurea.ambilightrangespreadradius"), contextmenus: prefManager.getBoolPref("extensions.AmbientAurea.contextmenus"), ambilightfixcolor: prefManager.getBoolPref("extensions.AmbientAurea.ambilightfixcolor"), ambilight4color: prefManager.getBoolPref("extensions.AmbientAurea.ambilight4color"), ambilightvarcolor: prefManager.getBoolPref("extensions.AmbientAurea.ambilightvarcolor"), ambilightcolorhex: prefManager.getCharPref("extensions.AmbientAurea.ambilightcolorhex"), ambilight1colorhex: prefManager.getCharPref("extensions.AmbientAurea.ambilight1colorhex"), ambilight2colorhex: prefManager.getCharPref("extensions.AmbientAurea.ambilight2colorhex"), ambilight3colorhex: prefManager.getCharPref("extensions.AmbientAurea.ambilight3colorhex"), ambilight4colorhex: prefManager.getCharPref("extensions.AmbientAurea.ambilight4colorhex"), count: prefManager.getBoolPref("extensions.AmbientAurea.count"), slideshow: prefManager.getBoolPref("extensions.AmbientAurea.slideshow"), slideshowrefresh: prefManager.getCharPref("extensions.AmbientAurea.slideshowrefresh")});
			}
			else if ( request.name == "opacitysaveme" ) {
				Services.prefs.setCharPref("extensions.AmbientAurea.interval", request.value);
			}
			else if ( request.name == "imgurl" ) {
				Services.prefs.setCharPref("extensions.AmbientAurea.getimgurl", request.value);
			}
        });
    };
	
    ns.onToolbarButtonClick = function() {
        var tab = documentToTab(gBrowser.contentDocument);
        firefox.tabs.executeScript(tab, {file: "chrome://AmbientAurea/content/js/aaselector.js"});
    };
	
    ns.onObjectAmbientAureaClick = function() {
		var tab = documentToTab(gBrowser.contentDocument);
		firefox.tabs.executeScript(tab, {file: "chrome://AmbientAurea/content/js/aa.js"});
    };
	
    var documentToTab = function(doc) {
        return {
            document: doc,
            url: doc.location.href
        }
    };

    var evalInSandbox = function(code, codebase, sandbox ){
        if (Components.utils && Components.utils.Sandbox) {
            // DP beta+
            Components.utils.evalInSandbox(code, sandbox);
        } else if (Components.utils && Components.utils.evalInSandbox) {
            // DP alphas
            Components.utils.evalInSandbox(code, codebase, sandbox);
        } else if (Sandbox) {
            // 1.0.x
            evalInSandbox(code, sandbox, codebase);
        } else {
            throw new Error("Could not create sandbox.");
        }
    };

    var getFileContent = function( file ) {
        var ioService=Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService);
        var scriptableStream=Components
            .classes["@mozilla.org/scriptableinputstream;1"]
            .getService(Components.interfaces.nsIScriptableInputStream);
        var unicodeConverter=Components
            .classes["@mozilla.org/intl/scriptableunicodeconverter"]
            .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        unicodeConverter.charset="UTF-8";

        var channel=ioService.newChannel( file, "UTF-8", null);
        var input=channel.open();
        scriptableStream.init(input);
        var str=scriptableStream.read(input.available());
        scriptableStream.close();
        input.close();

        try {
            return unicodeConverter.ConvertToUnicode(str);
        } catch (e) {
            return str;
        } 
    };

    var console = {};
    console._service = Components.classes["@mozilla.org/consoleservice;1"]
        .getService(Components.interfaces.nsIConsoleService);
    console.log = function(msg) {
        console._service.logStringMessage(msg);
    };

    var firefox = {};

    firefox.tabs = {};
    firefox.tabs.executeScript = function(tab, details) {
        var unsafeWin = tab.document.defaultView;
		//unsafeWin.__exposedProps__ = { unsafeWin: "wr" }; // not needed
        var safeWin = new XPCNativeWrapper(unsafeWin);
		//safeWin.__exposedProps__ = { safeWin: "wr" }; // not needed
		//var sandbox = new Components.utils.Sandbox(safeWin);
		var systemPrincipal = Cc["@mozilla.org/systemprincipal;1"]  // fix for __exposedProps__
                              .createInstance(Ci.nsIPrincipal); 
        var sandbox = new Components.utils.Sandbox( systemPrincipal );
        sandbox.window = safeWin;
        sandbox.document = sandbox.window.document;
        sandbox.unsafeWindow = unsafeWin;
        sandbox.__proto__ = sandbox.window;
        sandbox.firefox = {};
        sandbox.firefox.extension = new firefox.tabs.extension(tab.document);
        sandbox.console = console;
        var code = (typeof details.code != "undefined"
                    ? details.code
                    : ( typeof details.file != "undefined" ? getFileContent(details.file) : undefined ) );
        if ( code ) {
            try {
                evalInSandbox( code, tab.url, sandbox );
            } catch ( e ) {
                console.log("[ERROR] " + e );
            }
        }
    };

    firefox.tabs.event_id = ns.extension_id+".tabs.Request";
    firefox.tabs.request = {};
    
    firefox.tabs.sendRequest = function(tab, request, requestCallback) {
        var evt = tab.document.createEvent("Events");
        evt.initEvent(firefox.tabs.event_id, true, false);
        firefox.tabs.request = {
            data: request,
            callback: requestCallback
        };
        tab.document.dispatchEvent(evt);
    };

    firefox.tabs.extension = function(doc) {
        this.document = doc;
        this.event_id = firefox.tabs.event_id;

        var listeners = [];
        var handler = function(evt) {
            var request = firefox.tabs.request;
            for ( var i=0; i<listeners.length; i++ ) {
                listeners[i](request.data, null, request.callback);
            }
        };

        this.onRequest = {
            addListener: function(listener) {
                listeners.push(listener);
            },
            
            removeListener: function(listener) {
                for ( var i=0; i<listeners.length; i++ ) {
                    if ( listener == listeners[i] ) {
                        listeners.splice(i, 1);
                    }
                }
            }
        };
        doc.addEventListener(firefox.tabs.event_id, handler, false, true );
    };
    
    var listeners = [];
    firefox.tabs.extension.prototype.sendRequest = function(request, responseCallback) {
        if ( typeof responseCallback!="function" ) {
            responseCallback = function() {};
        }
        for ( var i=0; i<listeners.length; i++ ) {
            listeners[i](request, { tab: documentToTab(this.document) }, responseCallback);
        }
    };

    firefox.extension = {};
    firefox.extension.onRequest = {
        addListener: function(listener) {
            listeners.push(listener);
        },
        removeListener: function(listener) {
            for ( var i=0; i<listeners.length; i++ ) {
                if ( listener == listeners[i] ) {
                    listeners.splice(i, 1);
                }
            }
        }
    };
})(AmbientAurea);

window.addEventListener("load", function() {AmbientAurea.init();}, false);